#!/usr/bin/python
# -*- coding: utf8 -*-

import irclib
import ircbot
import re
import urllib
import json

def strp(txt):
	return txt.lower().replace(' ', '').replace('is', '').replace('the', '').replace('fucking', '').replace('iz', '').replace('are', '').replace('re', '').replace('\'', '').replace('you', '').replace(',', '').replace(':', '').replace('an', '').replace('rabbit', '')

# Init
class Rabbit(ircbot.SingleServerIRCBot):
	def __init__(self):
		ircbot.SingleServerIRCBot.__init__(self, [('irc.freenode.net', 8001)], 'RabbitBot', 'RabbitBot')
		
		self.memserv = []
		self.teached = []
		self.logs = []
		self.logs.append(['#elementary', '(RabbitBot has been restarted here)'])
		self.logs.append(['#elementary-web', '(RabbitBot has been restarted here)'])
		self.logs.append(['#elementary-dev', '(RabbitBot has been restarted here)'])
		self.translate = {}
		self.waitns = []
	
	# Join #elementary
	def on_welcome(self, serv, ev):
		serv.join('#elementary')
		serv.join('#elementary-dev')
		serv.join('#elementary-web')

	# When a message is sent
	def on_pubmsg(self, serv, ev):
		chan = ev.target()
		
		try:
			message = ev.arguments()[0]
			nick = irclib.nm_to_n(ev.source())
			ops = ['agent00tai', 'kalikiana', 'aroman', 'lallenlowe', 'Marin_M', 'ammonkey', 'DanRabbit', 'cassidyjames']
			
			insults = ['stupid', 'dumb', 'idiot', 'bastard', 'suck', 'fag', 'awful', 'bad']
			good = ['awesome', 'cool', 'smart', 'notstupid', 'ilove']
			hello = ['hey', 'hello', 'sup', 'bonjour', 'whatsup', 'yo', 'hi']
			strpd = strp(message)
			
			for i in insults:
				if 'bot' + i in strpd:
					serv.kick(chan, nick, 'Grrrrrr...')
			
			for i in good:
				if 'bot' + i in strpd or 'lovebot' in strpd:
					serv.privmsg(chan, '<3')
			
			for i in hello:
				if 'bot' + i in strpd or 'bot' + i in strpd:
					serv.privmsg(chan, nick + ': ' + i.capitalize())
			
			# Add to logs
			self.logs.append([chan, '<' + nick + '> ' + message])
			
			# Bug number(s) ?
			bugs = re.findall('bugs?((?: \d{1,10})+)', message.lower().replace('#', '').replace('and ', '').replace(',', ''))
			
			if bugs:
				for i in bugs:
					i = i[1:]
					
					if ' ' in i:
						for j in i.split(' '):
							serv.privmsg(chan, 'https://bugs.launchpad.net/bugs/%s' % j)
					
					else:
						serv.privmsg(chan, 'https://bugs.launchpad.net/bugs/%s' % i)
			
			# MemServ
			if '!memo' in message:
				if '|' in message.split('!memo')[1]:
					self.memserv.append([nick, message.split('!memo')[1].split('|')[1].strip(), message.split('!memo')[1].split('|')[0].strip()])
					serv.notice(nick, 'The message has been memorized.')
			
			# Google search
			elif '!google' in message:
				if '|' in message.split('!google')[1]:
					requesteduser = message.split('!google')[1].split('|')[1].strip()
					interesting = message.split('!google')[1].split('|')[0].strip().replace(' ', '+')
					serv.privmsg(chan, requesteduser + ': http://www.google.com/search?q=' + interesting)
				else:
					interesting = message.split('!google')[1].strip().replace(' ', '+')
					serv.privmsg(chan, 'http://www.google.com/search?q=' + interesting)
			
			# You should report a bug
			elif '!report ' in message:
				if '|' in message.split('!report')[1]:
					requesteduser = message.split('!report')[1].split('|')[1].strip()
					interesting = message.split('!report')[1].split('|')[0].strip().replace(' ', '+')
					serv.privmsg(chan, requesteduser + ': https://bugs.launchpad.net/' + interesting + '/+filebug')
				else:
					interesting = message.split('!report')[1].strip().replace(' ', '+')
					serv.privmsg(chan, 'https://bugs.launchpad.net/' + interesting + '/+filebug')
			
			# You should report a bug
			elif '!lp ' in message:
				if '|' in message.split('!lp')[1]:
					requesteduser = message.split('!lp')[1].split('|')[1].strip()
					interesting = message.split('!lp')[1].split('|')[0].strip()
					serv.privmsg(chan, requesteduser + ': https://launchpad.net/' + interesting)
				else:
					interesting = message.split('!lp')[1].strip()
					serv.privmsg(chan, 'https://launchpad.net/' + interesting)
			
			# Urban Dictionary
			elif '!ud ' in message:
				ud = urllib.urlopen('http://www.urbandictionary.com/define.php?term=' + message.split('!ud ')[1].replace('#', '')).read().replace('<br/>', ' ').replace('<br>', ' ').replace('<br />', ' ').replace('\n', '')
				
				if '</i>isn\'t defined <a href="/add.php?word=' in ud:
					
					serv.privmsg(chan, '“' + message.split('!ud ')[1] + '” is undefined.')
				
				else:
					ud = ud
					serv.privmsg(chan, re.sub('<.+?>', '', ud.split('<div class="definition">')[1].split('</div>')[0].replace('1. ', '')))
			
			# Link to the site
			elif '!site ' in message:
				if '|' in message.split('!site')[1]:
					requesteduser = message.split('!site')[1].split('|')[1].strip()
					interesting = message.split('!site')[1].split('|')[0].strip()
					serv.privmsg(chan, requesteduser + ': http://elementaryos.org/node/' + interesting)
				else:
					interesting = message.split('!site')[1].strip()
					serv.privmsg(chan, 'http://elementaryos.org/node/' + interesting)
			
			# Lallenlowe?
			elif '!allensay' in message:
				serv.privmsg(chan, '\o/ -<' + message.split('!allensay')[1].upper())
				serv.privmsg(chan, ' |')
				serv.privmsg(chan, '/ \\')
			
			# Lallenlowe?
			elif '!wir' in message:
				targetnick = message.split('!wir')[1].replace('|', '').strip()
				
				if targetnick != '':
					serv.privmsg(chan, targetnick + ': When it\'s ready.')
					
				else:
					serv.privmsg(chan, 'When it\'s ready.')
			
			# Lallenlowe?
			elif '!status' in message.lower():
				serv.privmsg(chan, 'Still alive.')
			
			# Help?
			elif '!help' in message:
				znick = nick
				
				if message.split('!help')[1].strip() != '':
					znick = message.split('!help')[1].strip()
				
				serv.notice(znick, '!help - show this help message')
				serv.notice(znick, '!help <user> - show this help message for <user>')
				serv.notice(znick, '!logs - show #elementary\'s logs')
				serv.notice(znick, '!translate <language> - translate your messages from <language> to English')
				serv.notice(znick, '!translate off - stop translating')
				serv.notice(znick, '!ops - emergency: alert the operators')
				serv.notice(znick, '!ask <user> or !ask - request <user> to ask directly its question')
				serv.notice(znick, '!ugt <user> or !ugt - send a link to http://www.total-knowledge.com/~ilya/mips/ugt.html, if specified, to <user>')
				serv.notice(znick, '!wir <user> or !wir - say "When it\'s ready", if specified, to <user>')
				serv.notice(znick, '!google <search> | <user> - send a link to the Google search <search>, if specified, to <user>')
				serv.notice(znick, '!site <number> | <user> - send a link to http://elementaryos.org/node/<number>, if specified, to <user>')
				serv.notice(znick, '!report <project> | <user> - send a link to report a bug in the Launchpad project <project>, if specified, to <user>')
				serv.notice(znick, '!lp <project> | <user> - send a link to the Launchpad project <project> to <user>')
				serv.notice(znick, '!rabbitsay <message> - make a cute little bunny speak <message>')
				serv.notice(znick, '!kick <user> - kick <user>, if you\'re an operator')
				serv.notice(znick, '!memo <message> | <user> - send <message> to <user> when <user> will be connected')
				serv.notice(znick, '!voice <user> - autovoice for <user> on #elementary-web, if you\'re an operator')
				serv.notice(znick, '!unvoice <user> - remove autovoice for <user> on #elementary-web')
				serv.notice(znick, '!clearlogs - OPs only: clear the logs')
				serv.notice(znick, '!status - show the status of the bot')
				serv.notice(znick, 'bug <number> - automatically post a link to the Launchpad bug <number>')
				serv.notice(znick, '!ud <word> - define <word> from the Urban Dictionary')
				serv.notice(znick, 'lp:something or ppa:something - create a link to a Launchpad branch or PPA')
				
			# Rabbit?
			elif '!rabbitsay' in message:
				serv.privmsg(chan, '() ()')
				serv.privmsg(chan, '(=\'\'=) -<' + message.split('!rabbitsay')[1])
				serv.privmsg(chan, '( . )')
				serv.privmsg(chan, '(\')(\')')
				self.logs.append([chan, '() ()'])
				self.logs.append([chan, '(=\'\'=) -<' + message.split('!rabbitsay')[1]])
				self.logs.append([chan, '( . )'])
				self.logs.append([chan, '(\')(\')'])
			
			elif '!rabbit' in message:
				serv.privmsg(chan, '() ()')
				serv.privmsg(chan, '(=\'\'=)')
				serv.privmsg(chan, '( . )')
				serv.privmsg(chan, '(\')(\')')
				self.logs.append([chan, '() ()'])
				self.logs.append([chan, '(=\'\'=)'])
				self.logs.append([chan, '( . )'])
				self.logs.append([chan, '(\')(\')'])
			
			# Alert an operator?
			elif '!ops' in message:
				serv.notice(nick, 'Alert launched.')
				
				for i in ops:
					serv.notice(i, 'Alert from ' + nick + '.')
				
			# Kick?
			elif '!kick ' in message and nick in ops and message.split('!kick ')[1].lower().strip() != 'rabbitbot':
				serv.kick(chan, message.split('!kick ')[1])
				
			elif '!kick ' in message and nick in ops:
				serv.privmsg(chan, 'I\'m not so stupid.')
			
				
			elif '!logs' in message:
				chanlogs = ''
				
				for i in self.logs:
					if i[0] == chan:
						chanlogs += i[1] + '\n'
				
				targetnick = message.split('!logs')[1].replace('|', '').strip()
				params = urllib.urlencode({'api_option': 'paste', 'api_dev_key': 'b0c821ef533aba71de7b6c35869688d6', 'api_paste_code': chanlogs})
				f = urllib.urlopen('http://pastebin.com/api/api_post.php', params)
				
				if targetnick != '':
					serv.notice(targetnick, f.read())
					
				else:
					serv.notice(nick, f.read())
					
			elif '!clearlogs' in message:
				self.logs = []
				self.logs.append(['#elementary', '(RabbitBot has been restarted here)'])
				self.logs.append(['#elementary-web', '(RabbitBot has been restarted here)'])
				self.logs.append(['#elementary-dev', '(RabbitBot has been restarted here)'])
				serv.notice(nick, 'Logs has been cleared.')
			
			# Translate
			elif '!translate ' in message:
				languages = {'AFRIKAANS': 'af', 'ITALIAN': 'it', 'ALBANIAN': 'sq', 'JAPANESE': 'ja', 'ARABIC': 'ar', 'KOREAN': 'ko', 'BELARUSIAN': 'be', 'LATVIAN': 'lv', 'BULGARIAN': 'bg', 'LITHUANIAN': 'lt', 'CATALAN': 'ca', 'MACEDONIAN': 'mk', 'CHINESE': 'zh', 'MALAY': 'ms', 'CHINESE_SIMPLIFIED': 'zh-CN', 'MALTESE': 'mt', 'CHINESE_TRADITIONAL': 'zh-TW', 'NORWEGIAN': 'no', 'CROATIAN': 'hr', 'PERSIAN': 'fa', 'CZECH': 'cs', 'POLISH': 'pl', 'DANISH': 'da', 'PORTUGUESE': 'pt', 'DUTCH': 'nl', 'PORTUGUESE_PORTUGAL': 'pt-PT', 'ENGLISH': 'en', 'ROMANIAN': 'ro', 'ESTONIAN': 'et', 'RUSSIAN': 'ru', 'FILIPINO': 'tl', 'SERBIAN': 'sr', 'FINNISH': 'fi', 'SLOVAK': 'sk', 'FRENCH': 'fr', 'SLOVENIAN': 'sl', 'GALICIAN': 'gl', 'SPANISH': 'es', 'GERMAN': 'de', 'SWAHILI': 'sw', 'GREEK': 'el', 'SWEDISH': 'sv', 'HAITIAN_CREOLE': 'ht', 'TAGALOG': 'tl', 'HEBREW': 'iw', 'THAI': 'th', 'HINDI': 'hi', 'TURKISH': 'tr', 'HUNGARIAN': 'hu', 'UKRAINIAN': 'uk', 'ICELANDIC': 'is', 'VIETNAMESE': 'vi', 'INDONESIAN': 'id', 'WELSH': 'cy', 'IRISH': 'ga', 'YIDDISH': 'yi'}
				langcodes = ['sv', 'lt', 'hi', 'tl', 'nl', 'th', 'tl', 'vi', 'sq', 'ht', 'fa', 'es', 'ko', 'af', 'zh-CN', 'pt', 'id', 'fi', 'de', 'zh-TW', 'ja', 'fr', 'pl', 'ga', 'hu', 'ro', 'no', 'ru', 'sw', 'da', 'is', 'tr', 'iw', 'sl', 'be', 'gl', 'el', 'sk', 'en', 'it', 'et', 'uk', 'cs', 'ms', 'pt-PT', 'yi', 'mt', 'hr', 'cy', 'mk', 'lv', 'sr', 'ar', 'bg', 'zh', 'ca']
				
				if '|' in message.split('!translate')[1]:
					nick2 = message.split('!translate')[1].split('|')[1].strip()
					
					if message.split('!translate')[1].split('|')[0].strip().upper() in languages:
						self.translate[nick2] = languages[message.split('!translate')[1].split('|')[0].strip().upper()]
						serv.notice(nick2, 'Type something, I\'ll translate.')
						
					elif message.split('!translate')[1].split('|')[0].strip().lower() == 'off' and nick2 in self.translate:
						del self.translate[nick2]
						
					elif message.split('!translate')[1].split('|')[0].strip().lower() in langcodes:
						self.translate[nick2] = message.split('!translate')[1].split('|')[0].strip().lower()
						serv.notice(nick2, 'Type something, I\'ll translate.')
					
					else:
						serv.notice(nick2, 'Please enter the name of a language, like french, german or spanish, or \'off\'.')
				
				else:
					if message.split('!translate')[1].strip().upper() in languages:
						self.translate[nick] = languages[message.split('!translate')[1].strip().upper()]
						serv.notice(nick, 'Type something, I\'ll translate.')
						
					elif message.split('!translate')[1].strip().lower() == 'off' and nick in self.translate:
						del self.translate[nick]
						
					elif message.split('!translate')[1].strip().lower() in langcodes:
						self.translate[nick] = message.split('!translate')[1].strip().lower()
						serv.notice(nick, 'Type something, I\'ll translate.')
					
					else:
						serv.notice(nick, 'Please enter a the name of a language, like french, german or spanish, or \'off\'.')
			
			# AutoVoice
			elif '!voice ' in message and nick in ops:
				open('../voice', 'a').write(message.split('!voice')[1].strip().lower() + '\n')
				serv.mode('#elementary-dev', '+v ' + message.split('!voice')[1].strip())
				serv.mode('#elementary-web', '+v ' + message.split('!voice')[1].strip())
				serv.notice(nick, message.split('!voice')[1].strip() + ' has been voiced.')
			
			# UnAutoVoice
			elif '!unvoice ' in message and nick in ops:
				content = open('../voice', 'r').read()
				open('../voice', 'w').write(content.replace(message.split('!unvoice')[1].strip().lower() + '\n', ''))
				serv.mode('#elementary-dev', '-v ' + message.split('!unvoice')[1].strip())
				serv.mode('#elementary-web', '-v ' + message.split('!unvoice')[1].strip())
				serv.notice(nick, message.split('!unvoice')[1].strip() + ' has been unvoiced.')
				
			elif '!ask' in message:
				targetnick = message.split('!ask')[1].replace('|', '').strip()
				
				if targetnick != '':
					serv.notice(targetnick, 'Please ask your question directly. Don\'t ask to ask, just ask!')
					
				else:
					serv.privmsg(chan, 'Please ask your question directly. Don\'t ask to ask, just ask!')
				
			elif '!ugt' in message.lower():
				targetnick = message.split('!ugt')[1].replace('|', '').strip()
				
				if targetnick != '':
					serv.notice(targetnick, 'http://www.total-knowledge.com/~ilya/mips/ugt.html')
					
				else:
					serv.privmsg(chan, 'http://www.total-knowledge.com/~ilya/mips/ugt.html')
			
			# Autotranslate
			elif nick in self.translate:
				r = urllib.urlopen('http://ajax.googleapis.com/ajax/services/language/translate?v=1.0&q=' + urllib.quote(str(message)) + '&langpair=' + self.translate[nick] + '%7Cen')
				translated = json.loads(unicode(r.read()))['responseData']['translatedText'].replace('&#39;', "'").replace('&quot;', '"')
				
				if message.lower().replace(' ', '') != translated.lower().replace(' ', ''):
					serv.privmsg(chan, '\'' + translated + '\'')
			
			if 'lp:~' in message:
				serv.privmsg(chan, 'https://code.launchpad.net/' + message.split('lp:')[1].split(' ')[0].split('!')[0].split('"')[0].split('?')[0].split('!')[0].split('.')[0].split(',')[0])
			
			elif 'lp:' in message:
				serv.privmsg(chan, 'https://code.launchpad.net/+branch/' + message.split('lp:')[1].split(' ')[0].split('!')[0].split('"')[0].split('?')[0].split('.')[0].split(',')[0])
			
			if 'ppa:' in message:
				ppa = message.split('ppa:')[1].split(' ')[0].split('!')[0].split('"')[0].split('?')[0].split('.')[0].split(',')[0].split('/')
				serv.privmsg(chan, 'https://code.launchpad.net/~' + ppa[0] + '/+archive/' + ppa[1])
			
		except:
			import sys
			serv.notice('Marin_M', str(sys.exc_info()[0]) + ', ' + str(sys.exc_info()[1]))
			self.memserv.append(['Marin_M', 'Marin_M', str(sys.exc_info()[0]) + ', ' + str(sys.exc_info()[1])])
			
	# /me
	def on_action(self, serv, ev):
		chan = ev.target()
		
		try:
			message = ev.arguments()[0]
			nick = irclib.nm_to_n(ev.source())
			
			# Logs
			self.logs.append([chan, '* ' + nick + ' ' + message])
			
			# Grrrr...
			'''grr = ['balmer', 'ballmer', 'mac', 'windows', 'osx', 'gates', 'apple', 'microsoft', 'steeve', 'steve', 'yves', 'rome', 'os x']
			grreed = False
			for i in grr:
				if grreed is False:
					if i in message.lower() and 'applet' not in message.lower():
						serv.privmsg(chan, 'Grrrrrr...')
						grreed = True '''
						
			# Autotranslate
			if nick in self.translate:
				r = urllib.urlopen('http://ajax.googleapis.com/ajax/services/language/translate?v=1.0&q=' + urllib.quote(message) + '&langpair=' + self.translate[nick] + '%7Cen')
				
				reponse = json.loads(r.read())['responseData']['translatedText'].replace('&#39;', "'")
				
				if reponse != message:
					serv.privmsg(chan, '\'' + nick + ' ' + reponse + '\'')

		except:
			import sys
			serv.notice('Marin_M', str(sys.exc_info()[0]) + ', ' + str(sys.exc_info()[1]))
			self.memserv.append(['Marin_M', 'Marin_M', str(sys.exc_info()[0]) + ', ' + str(sys.exc_info()[1])])

	# On join
	def on_join(self, serv, ev):
		chan = ev.target()
		
		try:
			chan = ev.target()
			nick = irclib.nm_to_n(ev.source())
			
			# Logs
			newLog = '* ' + nick + ' got connected.'
			if nick != 'RabbitBot' and self.logs[len(self.logs) - len(newLog):] != newLog:
				self.logs.append([chan, newLog])
			
			# AutoOP
			ops = ['agent00tai', 'kalikiana', 'aroman', 'lallenlowe', 'Marin_M', 'ammonkey', 'DanRabbit', 'cassidyjames']
			
			if nick in ops:
				self.waitns.append([nick, chan])
				serv.privmsg('NickServ', 'acc ' + nick)
			
			# AutoVoice
			elif chan == '#elementary-dev' or chan == '#elementaryweb':
				voiced = open('../voice', 'r').read().split('\n')
				if nick.lower() in voiced:
					serv.mode(chan, '+v ' + nick)
			
			# MemServ
			for i in self.memserv:
				if i[1] == nick:
					serv.notice(nick, 'Message from ' + i[0] + ': ' + i[2])
					self.memserv.remove(i)

		except:
			import sys
			serv.notice('Marin_M', str(sys.exc_info()[0]) + ', ' + str(sys.exc_info()[1]))
			self.memserv.append(['Marin_M', 'Marin_M', str(sys.exc_info()[0]) + ', ' + str(sys.exc_info()[1])])

	# On quit
	def on_quit(self, serv, ev):
		chan = ev.target()
		
		try:
			nick = irclib.nm_to_n(ev.source())
			newLog = '* ' + nick + ' got disconnected.'
			if nick != 'RabbitBot' and self.logs[len(self.logs) - len(newLog):] != newLog:
				self.logs.append([chan, newLog])

		except:
			import sys
			serv.notice('Marin_M', str(sys.exc_info()[0]) + ', ' + str(sys.exc_info()[1]))
			self.memserv.append(['Marin_M', 'Marin_M', str(sys.exc_info()[0]) + ', ' + str(sys.exc_info()[1])])

	# On quit
	def on_part(self, serv, ev):
		chan = ev.target()
		
		try:
			nick = irclib.nm_to_n(ev.source())
			newLog = '* ' + nick + ' got disconnected.'
			if nick != 'RabbitBot' and self.logs[len(self.logs) - len(newLog):] != newLog:
				self.logs.append([chan, newLog])
		
		except:
			import sys
			serv.notice('Marin_M', str(sys.exc_info()[0]) + ', ' + str(sys.exc_info()[1]))
			self.memserv.append(['Marin_M', 'Marin_M', str(sys.exc_info()[0]) + ', ' + str(sys.exc_info()[1])])
	
	def on_privnotice(self, serv, ev):
		nick = irclib.nm_to_n(ev.source())
		msg = ev.arguments()[0]
		if nick.lower() == 'nickserv' and ' ACC ' in msg:
			user = msg.split(' ')[0]
			status = msg[-1:]
			
			for i in self.waitns:
				if i[0] == user:
					if status == '3' or status == '2':
						serv.mode(i[1], '+o ' + user)
					self.waitns.remove(i)
	
	def on_ctcp(self, serv, ev):
		if ev.arguments()[0].upper() == 'VERSION':
			serv.ctcp_reply(ev.source().split('!')[0], 'I\'m a rabbit!')
		
Rabbit().start()
